/*==============================================================================
日本 BeOS ネットワーク主催 《 JPBE.net in 秋葉原 第 2 弾》
Zeta Locale Kit 紹介 サンプルプログラム No.2
　～ダイナミック言語変更対応 GUI プログラム～
　by ＳＨＩＮＴＡ (shinta@jpbe.net)
==============================================================================*/

//------------------------------------------------------------------------------
#include "Sample2.h"
//------------------------------------------------------------------------------
// BeOS Headers
#include <Alert.h>
#include <Locale.h>
#include <MenuItem.h>
#include <Messenger.h>
//==============================================================================
TSample2App::TSample2App()
		: SUPER("application/x-vnd.JPBEnet-LocaleKitSample2")
{
	TSample2Win*	aWin;

	be_locale.LoadLanguageFile("Language/Dictionaries/Sample2");	// 現バージョンではシステム辞書しかロードされないようなので明示的にロード
	aWin = new TSample2Win(BRect(100, 100, 450, 200));
	aWin->Show();
}
//------------------------------------------------------------------------------
TSample2App::~TSample2App()
{
}
//------------------------------------------------------------------------------
void	TSample2App::AboutRequested()
{
	BAlert*	aAlert;

	aAlert = new BAlert(NULL, _T("Zeta Locale Kit Sample Program 2"), "OK");
	aAlert->Go();
}
//==============================================================================
TSample2Win::TSample2Win(BRect oFrame)
		: SUPER(oFrame, "", B_TITLED_WINDOW, 0)
{
	// タイトルバーの設定
	SetWindowTitle();
	// メニューバーの作成
	mMBar = new BMenuBar(BRect(0, 0, 0, 0), "MenuBar");
	AddChild(mMBar);
	CreateMenu();
	// ストリングビューの作成
	mStrView = new BStringView(BRect(10, 50, 300, 60), "StrView", "");
	AddChild(mStrView);
	SetStringViewText();
}
//------------------------------------------------------------------------------
TSample2Win::~TSample2Win()
{
}
//------------------------------------------------------------------------------
void	TSample2Win::CreateMenu()
{
	BMenu*			aMenu;
	BMenuItem*		aMItem;

	// ファイル
	aMenu = new BMenu(_T("File"));
		// 終了
		aMItem = new BMenuItem(_T("Quit"), new BMessage(B_QUIT_REQUESTED));
		aMenu->AddItem(aMItem);
	mMBar->AddItem(aMenu);
	// ヘルプ
	aMenu = new BMenu(_T("Help"));
		// バージョン情報
		aMItem = new BMenuItem(_T("About ..."), new BMessage(B_ABOUT_REQUESTED));
		aMItem->SetTarget(be_app);
		aMenu->AddItem(aMItem);
	mMBar->AddItem(aMenu);
}
//------------------------------------------------------------------------------
void	TSample2Win::DestroyMenu()
{
	BMenu*	aMenu;

	while  ( (aMenu = mMBar->SubmenuAt(0)) != NULL ) {
		mMBar->RemoveItem(aMenu);
		delete aMenu;
	}
}
//------------------------------------------------------------------------------
void	TSample2Win::LanguageChanged()
{
//	be_locale.LoadLanguageFile("Language/Dictionaries/Sample2");	// やってもダメ
	// タイトルバーの再設定
	SetWindowTitle();
	// メニューの再作成
	DestroyMenu();
	CreateMenu();
	// 説明の再表示
	SetStringViewText();
}
//------------------------------------------------------------------------------
void	TSample2Win::MessageReceived(BMessage* oMsg)
{
	switch ( oMsg->what ) {
	case B_LANGUAGE_CHANGED:
		LanguageChanged();
		break;
	default:
		SUPER::MessageReceived(oMsg);
	}
}
//------------------------------------------------------------------------------
bool	TSample2Win::QuitRequested()
{
	BMessage	aSendMsg(B_QUIT_REQUESTED);

	be_app_messenger.SendMessage(&aSendMsg);
	return true;
}
//------------------------------------------------------------------------------
void	TSample2Win::SetStringViewText()
{
	mStrView->SetText(_T("This is a sample for dynamic language changing."));
}
//------------------------------------------------------------------------------
void	TSample2Win::SetWindowTitle()
{
	SetTitle(_T("Sample Program 2"));
}
//==============================================================================
int		main(int oArgC, char* oArgV[])
{
	TSample2App	aApp;

	aApp.Run();
	return 0;
}
//==============================================================================
